//
//  AppDelegate.m
//  GP_SDK_TestDemo
//
//  Created by ShaoDan on 2018/11/12.
//  Copyright © 2018年 Gainscha. All rights reserved.
//

#import "AppDelegate.h"
#import "TabBarController.h"

@interface AppDelegate ()

@end

@implementation AppDelegate


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Override point for customization after application launch.
    
    
    //创建窗口
    self.window=[[UIWindow alloc]init];
    self.window.backgroundColor = [UIColor whiteColor];
    
    self.window.frame=[UIScreen mainScreen].bounds;
    //设置根控制器
    
   self.window.rootViewController = [[TabBarController alloc]init];
    
    [self.window makeKeyAndVisible];
    
    
    //确定当前语言状态
    [self getCurrentLanguage];
    
    //判断是否是第一次启动
    if(![[NSUserDefaults standardUserDefaults] boolForKey:@"firstStart"]){
        [[NSUserDefaults standardUserDefaults] setBool:YES forKey:@"firstStart"];
        //设置本地语言
        if ([self isChineseLanguage]) {
            NSString *languageStr = @"zh-Hans";
            [[NSUserDefaults standardUserDefaults] setObject:languageStr forKey:AppLanguage];
        }else{
            NSString *languageStr = @"en";
            [[NSUserDefaults standardUserDefaults] setObject:languageStr forKey:AppLanguage];
        }
    }

    return YES;
}


#pragma mark --- 获取系统语言
- (NSString *)getCurrentLanguage
{
    NSArray *languages = [NSLocale preferredLanguages];
    NSString *currentLanguage = [languages objectAtIndex:0];
    return currentLanguage;
}

#pragma mark --- 判断当前系统语言为中文
- (BOOL)isChineseLanguage
{
    BOOL isChinese = NO;
    if ([[self getCurrentLanguage] rangeOfString:@"zh-Hans"].length > 0) {
        isChinese = YES;
        NSLog(@"当前是中文");
    }
    return isChinese;
}


- (void)applicationWillResignActive:(UIApplication *)application {
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and invalidate graphics rendering callbacks. Games should use this method to pause the game.
}


- (void)applicationDidEnterBackground:(UIApplication *)application {
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}


- (void)applicationWillEnterForeground:(UIApplication *)application {
    // Called as part of the transition from the background to the active state; here you can undo many of the changes made on entering the background.
}


- (void)applicationDidBecomeActive:(UIApplication *)application {
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}


- (void)applicationWillTerminate:(UIApplication *)application {
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}


@end
