//
//  BTTestViewController.m
//  GP_SDK_TestDemo
//
//  Created by ShaoDan on 2018/11/12.
//  Copyright © 2018年 Gainscha. All rights reserved.
//

#import "BTTestViewController.h"
#import "GprinterBlueToothSets.h"
#import "TscCommand.h"
#import "EscCommand.h"
#import "CPCLCommand.h"
#import "ViewController.h"
#import "HeadView.h"

#import <CoreBluetooth/CoreBluetooth.h>

#define ScreenWidth     [UIScreen mainScreen].bounds.size.width
#define ScreenHeight    [UIScreen mainScreen].bounds.size.height

#define CellIdentifier  @"CellIdentifier"


@interface BTTestViewController ()<UITableViewDelegate,UITableViewDataSource>

@property (nonatomic, strong) UITableView *TableView;

@property (strong, nonatomic)NSArray  *deviceArray;  /**< 扫描到蓝牙设备个数 */

@property(nonatomic,assign)NSInteger selectedIndex;

@property(nonatomic,strong)TscCommand *tc;
@property(nonatomic,strong)EscCommand *ec;
@property(nonatomic,strong)CPCLCommand *cc;

@property(strong,nonatomic)NSTimer *timer1;
@property(strong,nonatomic)NSTimer *timer2;
@property(strong,nonatomic)NSTimer *timer3;
@property(strong,nonatomic)NSTimer *timer4;


@property(nonatomic,assign)BOOL isTestPrint;
@property(nonatomic,assign)BOOL isCopyPrint;
@property(nonatomic,assign)BOOL isCheckStatus;
@property(nonatomic,assign)BOOL isModel;


@property(nonatomic,assign)int copyNum;

@property(nonatomic,strong)NSString *connectFlag;

@property(nonatomic,strong)CBPeripheral *cbp;






@end

@implementation BTTestViewController
#pragma mark - 懒加载 tableView -
- (UITableView *)TableView {
    
    if (!_TableView) {
        
        _TableView = [[UITableView alloc]initWithFrame:CGRectMake(10, 70, screen_width-20, 300) style:UITableViewStylePlain];
   
        
        _TableView.dataSource = self;
        _TableView.delegate = self;
        
        
        //列表边框
        _TableView.layer.borderWidth=1;
        _TableView.layer.borderColor=[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1].CGColor;
        
        [_TableView registerClass:[UITableViewCell class] forCellReuseIdentifier:CellIdentifier];
        
    }
    return _TableView;
}




- (void)viewDidLoad {
    [super viewDidLoad];
    
    //接受查询指令反馈过来的东西
    [[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(BlueToothPrinter:) name:@"BlueToothPrinter" object:nil];

    
    
    self.view.backgroundColor = [UIColor whiteColor];
    
    self.selectedIndex = -1;
    
    [self setUI];
    
    
    
    self.deviceArray = [NSArray array];

    //扫描
    [[GprinterBlueToothSets sharedInstance] startScanPerpheralSuccess:^(NSArray<CBPeripheral *> *perpherals, BOOL isTimeout) {
        
    
        self.deviceArray = perpherals;
        
        [self.TableView reloadData];
        
    } failure:^(CBManagerStateError error) {
      
        NSLog(@"%ld",(long)error);
        
    } withTimeout:15];
    

    
    // Do any additional setup after loading the view.
}
-(void)setUI{
    
    
    HeadView *header = [[HeadView alloc] initWithTitle:NSLocalizedString(@"蓝牙",nil)];
    [self.view addSubview:header];
    
    
    [self.view addSubview:self.TableView];

    [self.TableView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(header.mas_bottom).with.offset(20);
        make.left.equalTo(self.view).with.offset(10);
        make.size.mas_equalTo(CGSizeMake(screen_width-20, 300));
    }];
    
    
    
    UIButton *statusBtn = [[UIButton alloc]init];
    [statusBtn setTitle:NSLocalizedString(@"查询状态",nil) forState:UIControlStateNormal];
    [statusBtn setTitleColor:[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1] forState:UIControlStateNormal];
    
    statusBtn.layer.borderWidth=1;
    statusBtn.layer.borderColor=[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1].CGColor;
    [self.view addSubview: statusBtn];
    
    [statusBtn addTarget:self action:@selector(checkStatus) forControlEvents:UIControlEventTouchUpInside];
    
    
    
    
    UIButton *testBtn = [[UIButton alloc]init];
    [testBtn setTitle:NSLocalizedString(@"测试打印",nil) forState:UIControlStateNormal];
    [testBtn setTitleColor:[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1] forState:UIControlStateNormal];
    
    testBtn.layer.borderWidth=1;
    testBtn.layer.borderColor=[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1].CGColor;
    [self.view addSubview: testBtn];
    
    
    [testBtn addTarget:self action:@selector(BTtest) forControlEvents:UIControlEventTouchUpInside];
    
    
    
    UIButton *continuityBtn = [[UIButton alloc]init];
    [continuityBtn setTitle:NSLocalizedString(@"连续打印",nil) forState:UIControlStateNormal];
    [continuityBtn setTitleColor:[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1] forState:UIControlStateNormal];
    
    continuityBtn.layer.borderWidth=1;
    continuityBtn.layer.borderColor=[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1].CGColor;
    [self.view addSubview: continuityBtn];
    
    [continuityBtn addTarget:self action:@selector(OneByOne) forControlEvents:UIControlEventTouchUpInside];

    
 
    
    
    [statusBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.TableView.mas_bottom).offset(50);
        make.left.equalTo(self.view).offset(10);
        make.right.equalTo(self.view).offset(-10);
        make.height.mas_equalTo(@36);
    }];
    
    
    [testBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(statusBtn.mas_bottom).offset(20);
        make.left.equalTo(self.view).offset(10);
        make.right.equalTo(self.view).offset(-10);
        make.height.mas_equalTo(@36);
    }];
    
    
    [continuityBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(testBtn.mas_bottom).offset(20);
        make.left.equalTo(self.view).offset(10);
        make.right.equalTo(self.view).offset(-10);
        make.height.mas_equalTo(@36);
    }];
    

}



- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    
     return self.deviceArray.count;
    
}

-(CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section
{
    return 40;
}

-(UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section
{
    
  
        UIView *headerView=[[UIView alloc]init];
        headerView.backgroundColor=[UIColor whiteColor];
        UILabel *label = [[UILabel alloc]initWithFrame:CGRectMake(10, 10, 100, 30)];
        label.text = NSLocalizedString(@"蓝牙列表",nil);
        label.font=[UIFont systemFontOfSize:14];
        label.textColor=[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1];
        [headerView addSubview:label];
        
        return headerView;
    
    
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
   
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    
    if (cell == nil) {
            cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
        }
    
    
    CBPeripheral *peripherral =[self.deviceArray objectAtIndex:indexPath.row];
        
    
    cell.textLabel.text = [NSString stringWithFormat:@"%@:%@",NSLocalizedString(@"名称",nil),peripherral.name];
    cell.textLabel.textColor = [UIColor blackColor];
    
    if (self.selectedIndex == indexPath.row) {
        cell.textLabel.textColor = [UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1];
    }
    
    return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    
    CBPeripheral *peripheral = [self.deviceArray objectAtIndex:indexPath.row];
    
    //连接
    [[GprinterBlueToothSets sharedInstance]connectPeripheral:peripheral completion:^(CBPeripheral *perpheral, NSError *error) {
        if (error) {
            

            [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"连接失败",nil)];
            [SVProgressHUD dismissWithDelay:0.9f];
            
        }else{
            
            self.connectFlag = @"连接成功";
            self.cbp = perpheral;
            
            //判断当前模式
            [self commandCheck:3];
            
            self.selectedIndex = indexPath.row;
            [self.TableView reloadData];
            
        }
    }];
    
}



- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    return YES;
}
- (NSString *)tableView:(UITableView *)tableView titleForDeleteConfirmationButtonForRowAtIndexPath:(NSIndexPath *)indexPath{
    
    return  @"OFF" ;
}

- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if ([self.connectFlag isEqualToString:@"连接成功"]) {
      
        CBPeripheral *peripheral = [self.deviceArray objectAtIndex:indexPath.row];
        
        //断开连接
        [[GprinterBlueToothSets sharedInstance]cancelPeripheral:peripheral];
        
        self.connectFlag = @"";
        
        [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"已断开",nil)];
        [SVProgressHUD dismissWithDelay:0.9f];
        
        self.selectedIndex = -1;
    
        [self.TableView reloadData];
        
    }else{
        
        [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"你没有连接过当前的打印机",nil)];
        [SVProgressHUD dismissWithDelay:0.9f];
        
        
        
    }
   
     
    
}




#pragma mark - 查询状态
-(void)checkStatus
{

    
    if ([self.connectFlag isEqualToString:@"连接成功"]) {
        
        [self commandCheck:2];
        
    }else{
        
        [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"请先连接好打印机",nil)];
        [SVProgressHUD dismissWithDelay:0.9f];
        
    }
}


#pragma mark - 测试打印
-(void)BTtest
{
    if ([self.connectFlag isEqualToString:@"连接成功"]) {
          [self commandCheck:0];
    }else{
        
        [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"请先连接好打印机",nil)];
        [SVProgressHUD dismissWithDelay:0.9f];
        
    }
    
  

}


-(void)commandCheck:(int)n{
    
    if (n == 0) {
        self.isTestPrint = YES;
        self.isCopyPrint = NO;
        self.isCheckStatus = NO;
        self.isModel = NO;
        
    }else if (n == 1){
        
        self.isCopyPrint = YES;
        self.isTestPrint = NO;
        self.isCheckStatus = NO;
        self.isModel = NO;


    }else if(n == 2){
        
        self.isCopyPrint = NO;
        self.isTestPrint = NO;
        self.isCheckStatus = YES;
        self.isModel = NO;

        
    }else if (n == 3){
       
        self.isCopyPrint = NO;
        self.isTestPrint = NO;
        self.isCheckStatus = NO;
        self.isModel = YES;
    }
    else{
        
        return;
    }
    
    //先发送查询指令判断当前打印机是哪个模式
    self.timer1 = [NSTimer scheduledTimerWithTimeInterval:1.0 target:self selector:@selector(escCheck) userInfo:nil repeats:NO];
    
    //
    self.timer2 = [NSTimer scheduledTimerWithTimeInterval:2.5 target:self selector:@selector(cpclCheck) userInfo:nil repeats:NO];
    
    self.timer3 = [NSTimer scheduledTimerWithTimeInterval:3.6 target:self selector:@selector(tscCheck) userInfo:nil repeats:NO];
    
    self.timer4 = [NSTimer scheduledTimerWithTimeInterval:4.0 target:self selector:@selector(chooseWrong) userInfo:nil repeats:NO];

}

-(void)escCheck{
    
    
    [[GprinterBlueToothSets sharedInstance]addQueryPrinterStatusOfESC];



}


-(void)cpclCheck{

    
    [[GprinterBlueToothSets sharedInstance]addQueryPrinterStatusOfCPCL];

}
-(void)tscCheck{
    
    
    [[GprinterBlueToothSets sharedInstance]addQueryPrinterStatusOfTSC];
  

}


-(void)chooseWrong
{
    
    self.connectFlag = @"";
    
    self.selectedIndex = -1;

    [[GprinterBlueToothSets sharedInstance]cancelPeripheral:self.cbp];
    
    [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"蓝牙打印机连接失败",nil)];
    [SVProgressHUD dismissWithDelay:0.9f];
    
    [self.TableView reloadData];

    
}


#pragma mark - 通知


-(void)BlueToothPrinter:(NSNotification*)notification
{
    if ([notification.object isEqualToString:@"CPCL"]) {
        
        [self.timer3 invalidate];
        [self.timer4 invalidate];

        
        if (self.isModel) {
            [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"连接成功,当前是面单模式",nil)];
            [SVProgressHUD dismissWithDelay:1.2f];
        }
        
        
        if (self.isCheckStatus) {
            
            NSArray *keysArray = [[GprinterBlueToothSets sharedInstance].CpclValue allKeys];
            NSMutableArray *valueArr = [NSMutableArray array];
            
            NSString *value;
            for (int i = 0; i < keysArray.count; i++)
            {
                
                //根据键值处理字典中的每一项
                
                NSString *key = keysArray[i];
                
                [valueArr addObject:[GprinterBlueToothSets sharedInstance].CpclValue [key]];
                
                NSLog(@"%@",key);
                
            }
            value = [valueArr componentsJoinedByString:@"  , "];
            
            
            [SVProgressHUD showInfoWithStatus:value];
            [SVProgressHUD dismissWithDelay:2.2f];
//
        }
       
        
        
     
        
        if (self.isTestPrint) {
          
            self.cc = [[CPCLCommand alloc]init];
            
            //初始化
            [self.cc addInitializePrinterwithOffset:0 withHeight:1130 withQTY:1];
            
            //居中
            [self.cc addJustification:CENTER];
            [self.cc addSetmagWithWidthScale:1 withHeightScale:1];
            
            //文字
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:30 withContent:@"Sample"];
            
            [self.cc addSetmagWithWidthScale:0 withHeightScale:0];
            [self.cc addJustification:LEFT];
            
            
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:65 withContent:@"Print text"];
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:95 withContent:@"Welcom to use SMARNET printer!"];
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:135 withContent:@"佳博智匯標籤打印機"];
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:195 withContent:@"智汇"];
            
            [self.cc addJustification:CENTER];
            
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:195 withContent:@"网络"];
            [self.cc addJustification:RIGHT];
            
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:195 withContent:@"设备"];
            
            
            [self.cc addJustification:LEFT];
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:230 withContent:@"Print bitmap!"];
            
            
            //打印图片
            UIImage *img = [UIImage imageNamed:@"gprinter"];
            [self.cc addGraphics:COMPRESSED WithXstart:0 withYstart:255 withImage:img withMaxWidth:385];
            
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:645 withContent:@"Print code128!"];
            
            
            //条码文字注释
            [self.cc addBarcodeTextWithFont:5 withOffset:2];
            //条码
            [self.cc addBarcode:BARCODE withType:Code128 withWidth:1 withRatio:Point0 withHeight:50 withXstart:0 withYstart:680 withString:@"SMARNET"];
            //关闭注释
            [self.cc addBarcodeTextOff];
            
            
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:775 withContent:@"Print QRcode!"];
            
            
            [self.cc addQrcode:BARCODE withXstart:0 withYstart:810 with:2 with:6 withString:@"QRcode"];
            
            
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:1010 withContent:@"Completed"];
            
            [self.cc addJustification:LEFT];
            
            //打印
            [self.cc addPrint];
            
            //发送
            
            [[GprinterBlueToothSets sharedInstance]sendPrintData:[self.cc sendCData] completion:^(CBPeripheral *connectPerpheral, BOOL completion, NSString *error) {
                
                NSLog(@"写入结：%d---错误:%@",completion,error);
            }];
            
        }
        
        
        
        
        if (self.isCopyPrint) {
            
        
            
            self.cc = [[CPCLCommand alloc]init];
            
            //初始化
            [self.cc addInitializePrinterwithOffset:0 withHeight:1130 withQTY:1];
            
            //居中
            [self.cc addJustification:CENTER];
            [self.cc addSetmagWithWidthScale:1 withHeightScale:1];
            
            //文字
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:30 withContent:@"Sample"];
            
            [self.cc addSetmagWithWidthScale:0 withHeightScale:0];
            [self.cc addJustification:LEFT];
            
            
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:65 withContent:@"Print text"];
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:95 withContent:@"Welcom to use SMARNET printer!"];
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:135 withContent:@"佳博智匯標籤打印機"];
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:195 withContent:@"智汇"];
            
            [self.cc addJustification:CENTER];
            
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:195 withContent:@"网络"];
            [self.cc addJustification:RIGHT];
            
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:195 withContent:@"设备"];
            
            
            [self.cc addJustification:LEFT];
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:230 withContent:@"Print bitmap!"];
            
            
            //打印图片
            UIImage *img = [UIImage imageNamed:@"gprinter"];
            [self.cc addGraphics:COMPRESSED WithXstart:0 withYstart:255 withImage:img withMaxWidth:385];
            
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:645 withContent:@"Print code128!"];
            
            
            //条码文字注释
            [self.cc addBarcodeTextWithFont:5 withOffset:2];
            //条码
            [self.cc addBarcode:BARCODE withType:Code128 withWidth:1 withRatio:Point0 withHeight:50 withXstart:0 withYstart:680 withString:@"SMARNET"];
            //关闭注释
            [self.cc addBarcodeTextOff];
            
            
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:775 withContent:@"Print QRcode!"];
            
            
            [self.cc addQrcode:BARCODE withXstart:0 withYstart:810 with:2 with:6 withString:@"QRcode"];
            
            
            [self.cc addText:T withFont:FONT_04 withXstart:0 withYstart:1010 withContent:@"Completed"];
            
            [self.cc addJustification:LEFT];
            
            //打印
            [self.cc addPrint];
            
            while (self.copyNum-- != 0) {
               
                [[GprinterBlueToothSets sharedInstance]addQueryPrinterStatusOfCPCL];
               
                //发送
                [[GprinterBlueToothSets sharedInstance]sendPrintData:[self.cc sendCData] completion:^(CBPeripheral *connectPerpheral, BOOL completion, NSString *error) {
                    
                    NSLog(@"写入结：%d---错误:%@",completion,error);
                }];
                
                
            }
            self.isCopyPrint = NO;

           
            
        }
       
     
        
        
        
    }else if ([notification.object isEqualToString:@"ESC"]){
      
        [self.timer2 invalidate];
        [self.timer3 invalidate];
        [self.timer4 invalidate];

        
        if (self.isModel) {

            [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"连接成功,当前是票据模式",nil)];
            [SVProgressHUD dismissWithDelay:1.2f];
            
        }
      

        if (self.isCheckStatus) {
            
            NSArray *keysArray = [[GprinterBlueToothSets sharedInstance].EscValue allKeys];
            NSMutableArray *valueArr = [NSMutableArray array];
            
            NSString *value;
            for (int i = 0; i < keysArray.count; i++)
            {
                
                //根据键值处理字典中的每一项
                
                NSString *key = keysArray[i];
                
                [valueArr addObject:[GprinterBlueToothSets sharedInstance].EscValue [key]];
                
                NSLog(@"%@",key);
                
            }
            value = [valueArr componentsJoinedByString:@"  , "];
            
            
            [SVProgressHUD showInfoWithStatus:value];
            [SVProgressHUD dismissWithDelay:2.2f];
        }
        
        
        if (self.isTestPrint) {
        
            
            self.ec = [[EscCommand alloc]init];
            
            [self.ec addInitializePrinter];
            [self.ec addPrintAndFeedLines:3];
            [self.ec addSelectJustification:Middle];
            
            //倍宽倍高
            [self.ec addSelectPrintModes:48];
            
            [self.ec addText:@"Sample\n"];
            [self.ec addPrintAndLineFeed];
            
            //取消倍宽倍高
            [self.ec addSelectPrintModes:0];

            [self.ec addSelectJustification:Left];
            [self.ec addText:@"Print text\nWelcome to use SMARNET printer!\n"];

            /* 打印繁体中文 需要打印机支持繁体字库 */
            [self.ec addText:@"佳博智匯票據打印機\n"];
            [self.ec addPrintAndLineFeed];

            [self.ec addText:@"智汇"];
            [self.ec addSetHorAndVerMotionUnits:7 Y:0];
            [self.ec addSetAbsolutePrintPosition:159];
            [self.ec addText:@"网络"];
            [self.ec addSetAbsolutePrintPosition:266];
            [self.ec addText:@"设备"];
            [self.ec addPrintAndLineFeed];

            [self.ec addText:@"Print bitmap!\n"];

//            UIImage *img = [UIImage imageNamed:@"gprinter"];
//
//            [self.ec addRastBitImage:img Alignment:Middle maxWidth:300];

            [self.ec addText:@"Print code128\n"];

            [self.ec addSelectPrintingPositionForHRICharacters:2];
            [self.ec addSetBarcodeHeight:60];
            [self.ec addSetBarcodeWidth:1];

            [self.ec addCODE128:CodeB with:@"SMARNET"];
            [self.ec addPrintAndLineFeed];

            [self.ec addText:@"Print QRcode\n"];


            [self.ec addSelectSizeOfModuleForQRCode:3];
            [self.ec addSelectErrorCorrectionLevelForQRCode:48];
            [self.ec addStoreQRCodeData:@"www.smarnet.cc"];
            [self.ec addPrintQRCode];


            [self.ec addSelectJustification:Middle];
            [self.ec addText:@"Completed!\r\n"];


            [self.ec addGeneratePlus:Pin_5];

            [self.ec addPrintAndFeedLines:8];
            
            
            [self.ec addCutAndFeedPaper:12];
            
 
            [[GprinterBlueToothSets sharedInstance]sendPrintData:[self.ec sendRData] completion:^(CBPeripheral *connectPerpheral, BOOL completion, NSString *error) {
                NSLog(@"发送，%d，%@",completion,error);
            }];  //
            
            
            //
            [[GprinterBlueToothSets sharedInstance]PrintCompletedCallBack:^(NSData *data) {
                NSLog(@"打印完成了！");
            }];
      
        }
        
        
      
        if (self.isCopyPrint) {
            
            
            self.ec = [[EscCommand alloc]init];
            
            [self.ec addInitializePrinter];
            [self.ec addPrintAndFeedLines:3];
            [self.ec addSelectJustification:Middle];
            
//            倍宽倍高
            [self.ec addSelectPrintModes:48];

            [self.ec addText:@"Sample\n"];
            [self.ec addPrintAndLineFeed];
            
            //取消倍宽倍高
            [self.ec addSelectPrintModes:0];
            
            [self.ec addSelectJustification:Left];
            [self.ec addText:@"Print text\nWelcome to use SMARNET printer!\n"];
            
            /* 打印繁体中文 需要打印机支持繁体字库 */
            [self.ec addText:@"佳博智匯票據打印機\n"];
            [self.ec addPrintAndLineFeed];

            [self.ec addText:@"智汇"];
            [self.ec addSetHorAndVerMotionUnits:7 Y:0];
            [self.ec addSetAbsolutePrintPosition:159];
            [self.ec addText:@"网络"];
            [self.ec addSetAbsolutePrintPosition:266];
            [self.ec addText:@"设备"];
            [self.ec addPrintAndLineFeed];

            [self.ec addText:@"Print bitmap!\n"];

            UIImage *img = [UIImage imageNamed:@"gprinter"];

            [self.ec addRastBitImage:img Alignment:Middle maxWidth:300];

            [self.ec addText:@"Print code128\n"];

            [self.ec addSelectPrintingPositionForHRICharacters:2];
            [self.ec addSetBarcodeHeight:60];
            [self.ec addSetBarcodeWidth:1];

            [self.ec addCODE128:CodeB with:@"SMARNET"];
            [self.ec addPrintAndLineFeed];

            [self.ec addText:@"Print QRcode\n"];


            [self.ec addSelectSizeOfModuleForQRCode:3];
            [self.ec addSelectErrorCorrectionLevelForQRCode:48];
            [self.ec addStoreQRCodeData:@"www.smarnet.cc"];
            [self.ec addPrintQRCode];


            [self.ec addSelectJustification:Middle];
            [self.ec addText:@"Completed!\r\n"];


            [self.ec addGeneratePlus:Pin_5];

            [self.ec addPrintAndFeedLines:8];

//
            [self.ec addCutAndFeedPaper:48];

            
            while (self.copyNum -- != 0) {
                //发送
//                [[GprinterBlueToothSets sharedInstance]addQueryPrinterStatusOfESC];
                
                [[GprinterBlueToothSets sharedInstance]PrintCompletedCallBack:^(NSData *data) {
                    NSLog(@"打印完成~~~~~~~~~~~~");
                }];
                
                
                [[GprinterBlueToothSets sharedInstance]sendPrintData:[self.ec sendRData] completion:^(CBPeripheral *connectPerpheral, BOOL completion, NSString *error) {
                    
                    NSLog(@"写入结：%d---错误:%@",completion,error);
                }];
                
                
            }
            self.isCopyPrint = NO;
            
            
            
        }
        
        
        
        
    }else if ([notification.object isEqualToString:@"TSC"]){
        
        [self.timer4 invalidate];


        if (self.isModel) {
            [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"连接成功,当前是标签模式",nil)];
            [SVProgressHUD dismissWithDelay:1.2f];
        }
        
        if (self.isCheckStatus) {
            
            NSArray *keysArray = [[GprinterBlueToothSets sharedInstance].TscValue allKeys];
            NSMutableArray *valueArr = [NSMutableArray array];
            
            NSString *value;
            for (int i = 0; i < keysArray.count; i++)
            {
                
                //根据键值处理字典中的每一项
                
                NSString *key = keysArray[i];
                
                [valueArr addObject:[GprinterBlueToothSets sharedInstance].TscValue [key]];
                
                
                NSLog(@"%@",key);
                
            }
            value = [valueArr componentsJoinedByString:@"  , "];
            
            
            [SVProgressHUD showInfoWithStatus:value];
            [SVProgressHUD dismissWithDelay:2.2f];
            
        }
        
        
       
        
        if (self.isTestPrint) {
  
      
            self.tc = [[TscCommand alloc]init];
            
            [self.tc addSizeWithWidth:60 withHeight:60];
            [self.tc addGap:2 with:0];
            [self.tc addDirection:BACKWARD];
            [self.tc addReference:0 with:0];
            [self.tc addTear:@"ON"];
            [self.tc addClS];
            
            
            [self.tc  addTextWithXstart:10 withYstart:0 withFont:SIMPLIFIED_CHINESE withRotation:ROTATION_0 withMagnificationRateX:MUL_1 withMagnificationRateY:MUL_1 withContent:@"Welcome to use SMARNET printer"];
            
            
            UIImage *img = [UIImage imageNamed:@"gprinter"];
            [self.tc addBitmapWithXstart:10 withYstart:20 withMode:0 withImage:img maxWidth:300];
            
            
            [self.tc addQRCodeWithXstart:10 withYstart:330 ECClevel:LEVEL_L withCellwidth:5 withMode:@"A" withRotation:ROTATION_0 withString:@"www.smarnet.cc"];
            
            
            [self.tc add1DBarcodeWithXstart:10 withYstart:450 withType:CODE128 withHeight:100 withREADABLE:ENABEL withROTATION:ROTATION_0 narrow:2 wide:2 withString:@"SMARNET"];
            
            [self.tc addPrint:1 with:1];
            
            [self.tc addSound:2 with:10];
            [self.tc addCashdrwer:PIN_5 withT1:255 withT2:255];
            
            
            
            [[GprinterBlueToothSets sharedInstance]sendPrintData:[self.tc sendTData] completion:^(CBPeripheral *connectPerpheral, BOOL completion, NSString *error) {
                
                NSLog(@"写入结：%d---错误:%@",completion,error);
            }];
            
        }
        
        
        
        if (self.isCopyPrint) {
            
            self.tc = [[TscCommand alloc]init];
            
            [self.tc addSizeWithWidth:60 withHeight:60];
            [self.tc addGap:2 with:0];
            [self.tc addDirection:FORWARD];
            [self.tc addReference:0 with:0];
            [self.tc addTear:@"ON"];
            [self.tc addClS];
            
            
            [self.tc  addTextWithXstart:10 withYstart:0 withFont:SIMPLIFIED_CHINESE withRotation:ROTATION_0 withMagnificationRateX:MUL_1 withMagnificationRateY:MUL_1 withContent:@"Welcome to use SMARNET printer"];
            
            
            UIImage *img = [UIImage imageNamed:@"gprinter"];
            [self.tc addBitmapWithXstart:10 withYstart:20 withMode:0 withImage:img maxWidth:300];
            
            
            [self.tc addQRCodeWithXstart:10 withYstart:330 ECClevel:LEVEL_L withCellwidth:5 withMode:@"A" withRotation:ROTATION_0 withString:@"www.smarnet.cc"];
            
            
            [self.tc add1DBarcodeWithXstart:10 withYstart:450 withType:CODE128 withHeight:100 withREADABLE:ENABEL withROTATION:ROTATION_0 narrow:2 wide:2 withString:@"SMARNET"];
            
            [self.tc addPrint:self.copyNum with:1];
            
            [self.tc addSound:2 with:10];
            [self.tc addCashdrwer:PIN_5 withT1:255 withT2:255];
            
            
            
            [[GprinterBlueToothSets sharedInstance]sendPrintData:[self.tc sendTData] completion:^(CBPeripheral *connectPerpheral, BOOL completion, NSString *error) {
                
                NSLog(@"写入结：%d---错误:%@",completion,error);
            }];
            
            
        }
        
        
    
    }
}




#pragma mark - 连续打印



-(void)OneByOne
{ UIAlertController *alertController = [UIAlertController alertControllerWithTitle:nil message:NSLocalizedString(@"请输入份数",nil) preferredStyle:UIAlertControllerStyleAlert];
    //增加确定按钮；
    [alertController addAction:[UIAlertAction actionWithTitle:NSLocalizedString(@"确定",nil) style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        
        //文字内容
        UITextField * firstTF = [[UITextField alloc]init];
        
        
        firstTF = alertController.textFields.firstObject;
        
        if (firstTF.text.length == 0) {
            
            [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"份数不能为空",nil)];
            [SVProgressHUD dismissWithDelay:1.0f];
            
            return ;
        }
        
        int i = [firstTF.text intValue];
        

        if ([self.connectFlag isEqualToString:@"连接成功"]) {
          
            self.copyNum = i;
            
            [self commandCheck:1];
            
     
            

        
        }else{
            
           
            [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"请先连接好打印机",nil)];
            [SVProgressHUD dismissWithDelay:1.0f];
            
            
        }
       
 
    }]];
    
    
    
    //增加取消按钮；
    [alertController addAction:[UIAlertAction actionWithTitle:NSLocalizedString(@"取消",nil) style:UIAlertActionStyleDefault handler:nil]];
    
    //定义第一个输入框;
    
    [alertController addTextFieldWithConfigurationHandler:^(UITextField * _Nonnull textField) {
        
//        textField.placeholder = @"份数" ;
        
    }];
    //
    
    [self presentViewController:alertController animated:true completion:nil];
    
    
}


-(void)dealloc
{
    [[NSNotificationCenter defaultCenter]removeObserver:self name:@"BlueToothPrinter" object:nil];

    //解决内存泄漏问题
    if (self.timer1.isValid) {
        
        [self.timer1 invalidate];
        
    }
    if (self.timer2.isValid) {
        
        [self.timer2 invalidate];
        
    }
    if (self.timer3.isValid) {
        
        [self.timer3 invalidate];
        
    }
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
