//
//  ViewController.m
//  GP_SDK_TestDemo
//
//  Created by ShaoDan on 2018/11/12.
//  Copyright © 2018年 Gainscha. All rights reserved.
//

#import "ViewController.h"
#import "TscCommand.h"
#import "EscCommand.h"
#import "CPCLCommand.h"

#import "BTTestViewController.h"

#import "HeadView.h"

@interface ViewController ()<UITextFieldDelegate>
@property(nonatomic,strong)UITextField *ipField;
@property(nonatomic,strong)UITextField *portField;


@property(nonatomic,strong)TscCommand *tc;
@property(nonatomic,strong)EscCommand *ec;
@property(nonatomic,strong)CPCLCommand *cc;



@property(strong,nonatomic)NSTimer *timer1;
@property(strong,nonatomic)NSTimer *timer2;
@property(strong,nonatomic)NSTimer *timer3;


@property(strong,nonatomic)NSString *type;







@end

@implementation ViewController



- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.view.backgroundColor = [UIColor whiteColor];
    

    [self setUI];
    self.ipField.text = @"192.168.1.230";
    self.portField.text = @"9100";

    
    // Do any additional setup after loading the view, typically from a nib.
}


-(void)setUI{
    
    
    HeadView *header = [[HeadView alloc] initWithTitle:@"Wi-Fi"];
    [self.view addSubview:header];
    

    

    
    UILabel *label1 = [[UILabel alloc]init];
    label1.text = @"ip:";
    label1.textColor = [UIColor grayColor];
    [self.view addSubview:label1];
    

    
    
    UILabel *label2= [[UILabel alloc]init];
    label2.text = @"port:";
    label2.textColor = [UIColor grayColor];
    
    [self.view addSubview:label2];
    
    

    
    self.ipField = [[UITextField alloc]init];
    self.ipField.layer.borderWidth = 0.8 ;
    self.ipField.layer.borderColor =[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1].CGColor;
  
    //textField遵循协议
    self.ipField.delegate = self;
    
    [self.ipField addTarget:self action:@selector(TextFieldDidChange:) forControlEvents:UIControlEventEditingChanged];

    
    [self.view addSubview:self.ipField];
    
    
    self.portField = [[UITextField alloc]init];
    self.portField.layer.borderWidth = 0.8 ;
    self.portField.layer.borderColor =[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1].CGColor;

    //textField遵循协议
    self.portField.delegate = self;
    
    [self.portField addTarget:self action:@selector(TextFieldDidChange:) forControlEvents:UIControlEventEditingChanged];

    
    [self.view addSubview:self.portField];
    
    
    
    [label1 mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(header.mas_bottom).with.offset(40);
        
        make.size.mas_equalTo(CGSizeMake(50,30));
        
        make.left.equalTo(self.view).with.offset(10);
        
    }];
    
    [label2 mas_makeConstraints:^(MASConstraintMaker *make) {
        
        make.top.equalTo(label1.mas_bottom).with.offset(10);
        
        make.size.mas_equalTo(CGSizeMake(50,30));
        
        make.left.equalTo(self.view).with.offset(10);
        
    }];
    
    [self.ipField mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(label1);
        make.right.equalTo(self.view).with.offset(-10);
        
        make.height.mas_equalTo(@30);
        make.left.equalTo(label1.mas_right).with.offset(6);
        
    }];
    
    [self.portField mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(label2);
        make.right.equalTo(self.view).with.offset(-10);
        
        make.height.mas_equalTo(@30);
        
        make.left.equalTo(label2.mas_right).with.offset(6);
        
    }];
    
    [self setButtonList];
    
}


-(void)setButtonList
{
    UIButton *connectBtn = [[UIButton alloc]init];
    [connectBtn setTitle:NSLocalizedString(@"连接",nil) forState:UIControlStateNormal];
    [connectBtn setTitleColor:[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1] forState:UIControlStateNormal];
    
    connectBtn.layer.borderWidth=1;
    connectBtn.layer.borderColor=[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1].CGColor;
    [self.view addSubview: connectBtn];
    
    
    [connectBtn addTarget:self action:@selector(Connect) forControlEvents:UIControlEventTouchUpInside];
    
    
    
    UIButton *statusBtn = [[UIButton alloc]init];
    [statusBtn setTitle:NSLocalizedString(@"查询状态",nil) forState:UIControlStateNormal];
    [statusBtn setTitleColor:[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1] forState:UIControlStateNormal];
    
    statusBtn.layer.borderWidth=1;
    statusBtn.layer.borderColor=[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1].CGColor;
    [self.view addSubview: statusBtn];
    
    
    [statusBtn addTarget:self action:@selector(CheckStates) forControlEvents:UIControlEventTouchUpInside];
    
    
    UIButton *testBtn = [[UIButton alloc]init];
    [testBtn setTitle:NSLocalizedString(@"测试打印",nil) forState:UIControlStateNormal];
    [testBtn setTitleColor:[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1] forState:UIControlStateNormal];
    
    testBtn.layer.borderWidth=1;
    testBtn.layer.borderColor=[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1].CGColor;
    [self.view addSubview: testBtn];
    
    
    [testBtn addTarget:self action:@selector(Test) forControlEvents:UIControlEventTouchUpInside];
    
  
    
    UIButton *continuityBtn = [[UIButton alloc]init];
    [continuityBtn setTitle:NSLocalizedString(@"连续打印",nil) forState:UIControlStateNormal];
    [continuityBtn setTitleColor:[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1] forState:UIControlStateNormal];
    
    continuityBtn.layer.borderWidth=1;
    continuityBtn.layer.borderColor=[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1].CGColor;
    [self.view addSubview: continuityBtn];
    
   [continuityBtn addTarget:self action:@selector(Continuity) forControlEvents:UIControlEventTouchUpInside];
    
    UIButton *cutOffBtn = [[UIButton alloc]init];
    [cutOffBtn setTitle:NSLocalizedString(@"断开连接",nil) forState:UIControlStateNormal];
    [cutOffBtn setTitleColor:[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1] forState:UIControlStateNormal];
    
    cutOffBtn.layer.borderWidth=1;
    cutOffBtn.layer.borderColor=[UIColor colorWithRed:112/255.0 green:128/255.0 blue:144/255.0 alpha:1].CGColor;
    [self.view addSubview: cutOffBtn];
    
    [cutOffBtn addTarget:self action:@selector(cutOffLine) forControlEvents:UIControlEventTouchUpInside];

    [connectBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(self.portField.mas_bottom).offset(80);
        make.left.equalTo(self.view).offset(10);
        make.right.equalTo(self.view).offset(-10);
        make.height.mas_equalTo(@50);
    }];
    
    
    [statusBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(connectBtn.mas_bottom).offset(20);
        make.left.equalTo(self.view).offset(10);
        make.right.equalTo(self.view).offset(-10);
        make.height.mas_equalTo(@36);
    }];
    
    
    [testBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(statusBtn.mas_bottom).offset(20);
        make.left.equalTo(self.view).offset(10);
        make.right.equalTo(self.view).offset(-10);
        make.height.mas_equalTo(@50);
    }];
    
    [continuityBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(testBtn.mas_bottom).offset(20);
        make.left.equalTo(self.view).offset(10);
        make.right.equalTo(self.view).offset(-10);
        make.height.mas_equalTo(@50);
    }];

    [cutOffBtn mas_makeConstraints:^(MASConstraintMaker *make) {
        make.top.equalTo(continuityBtn.mas_bottom).offset(20);
        make.left.equalTo(self.view).offset(10);
        make.right.equalTo(self.view).offset(-10);
        make.height.mas_equalTo(@50);
    }];
    
    
    
    
}



#pragma mark - 连接，发送查询指令
-(void)Connect
{
    BOOL str  = [self isIPAddressWithString:self.ipField.text];
    
    if (str) {
    
    //按照时间顺序发送查询打印机状态的指令，有返回就是连接成功
    self.timer1 = [NSTimer scheduledTimerWithTimeInterval:0.1 target:self selector:@selector(ESCcheck) userInfo:nil repeats:NO];
    
    
    //
    self.timer2 = [NSTimer scheduledTimerWithTimeInterval:1.5 target:self selector:@selector(TSCcheck) userInfo:nil repeats:NO];
    //
    
    self.timer3 = [NSTimer scheduledTimerWithTimeInterval:2.0 target:self selector:@selector(theEnd) userInfo:nil repeats:NO];
  
    }else{
        [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"ip不符合规范",nil)];
        [SVProgressHUD dismissWithDelay:0.9f];
    }
    
}




//定时器发送


-(void)ESCcheck{
   
 
        //以防万一先调用断开的方法
        [[EscCommand shareInstance]CloseHost];
        
        //断开后再连接 防止程序崩溃
        [[EscCommand shareInstance]ConnectTheHost:self.ipField.text Port:(UInt16)[self.portField.text intValue] Timeout:10];
        
        
        
        //发送58票据的查询指令
        [[EscCommand shareInstance]addQueryPrinterStatusCallBack:^(NSData *data) {
            
            
            if (data) {
                
                [self.timer2 invalidate];
                [self.timer3 invalidate];
                
                self.type = @"ESC";
                
                NSLog(@"%@",self.type);
                
                
                [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"连接成功,当前是票据模式",nil)];
                [SVProgressHUD dismissWithDelay:1.2f];
                
                
                
            }
            
            
        }];
        
   
    
    
    
}




-(void)TSCcheck{
    //如果进入这个方法，就证明当前打印机是标签模式
    
    //断开不相干的链接
    [[EscCommand shareInstance]CloseHost];
    
    
    //连接正确的ip和port
    [[TscCommand shareInstance]ConnectTheHost:self.ipField.text Port:(UInt16)[self.portField.text intValue] Timeout:10];



    //发送查询指令
    [[TscCommand shareInstance]addQueryPrinterStatusCallBack:^(NSData *data) {
        
        if (data) {
            
            [self.timer3 invalidate];

            self.type = @"TSC";
            NSLog(@"%@",self.type);
            
            
            [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"连接成功,当前是标签模式",nil)];
            [SVProgressHUD dismissWithDelay:1.2f];


        }
        
        
    }];
    
    
    
    
}


-(void)theEnd
{
    //如果进入到这个方法就当连接失败
    [[TscCommand shareInstance]CloseHost];
    
    
    [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"连接打印机失败",nil)];
    [SVProgressHUD dismissWithDelay:1.2f];
}


#pragma mark - 查询状态
-(void)CheckStates{
    

    if ([self.type isEqualToString:@"ESC"]) {

        [[EscCommand shareInstance]addQueryPrinterStatusCallBack:^(NSData *data) {
         
            if (data) {
              
                NSArray *keysArray = [[EscCommand shareInstance].EscValue allKeys];
                NSMutableArray *valueArr = [NSMutableArray array];
                
                NSString *value;
                for (int i = 0; i < keysArray.count; i++)
                {
                    
                    //根据键值处理字典中的每一项
                    
                    NSString *key = keysArray[i];
                    
                    [valueArr addObject:[EscCommand shareInstance].EscValue [key]];
                    
                    
                }
                value = [valueArr componentsJoinedByString:@"  , "];
                
                NSLog(@"%@",value);
                
                [SVProgressHUD showInfoWithStatus:value];
                [SVProgressHUD dismissWithDelay:2.2f];
                
                [valueArr removeAllObjects];
            }
           
        }];
       

    }else if ([self.type isEqualToString:@"TSC"]){


        [[TscCommand shareInstance]addQueryPrinterStatusCallBack:^(NSData *data) {
           
            NSArray *keysArray = [[TscCommand shareInstance].TscValue allKeys];
            NSMutableArray *valueArr = [NSMutableArray array];
            
            NSString *value;
            for (int i = 0; i < keysArray.count; i++)
            {
                
                //根据键值处理字典中的每一项
                
                NSString *key = keysArray[i];
                
                [valueArr addObject:[TscCommand shareInstance].TscValue [key]];
                
                
            }
            value = [valueArr componentsJoinedByString:@"  , "];
            
            NSLog(@"%@",value);
            
            [SVProgressHUD showInfoWithStatus:value];
            [SVProgressHUD dismissWithDelay:2.2f];
            
        }];
       
    }else{


        [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"请先连接好打印机",nil)];
        [SVProgressHUD dismissWithDelay:1.0f];


    }
    
    
}

#pragma mark - 指令
-(NSMutableData*)command{
    
    
    [[EscCommand shareInstance] addInitializePrinter];
    
    [[EscCommand shareInstance] addPrintAndFeedLines:3];
    
    [[EscCommand shareInstance] addSelectJustification:Middle];
    
    //倍宽倍高
    
    [[EscCommand shareInstance] addSelectPrintModes:48];
    
    
    [[EscCommand shareInstance] addText:@"Sample\n"];
    
    [[EscCommand shareInstance] addPrintAndLineFeed];
    
    //取消倍宽倍高
    
    [[EscCommand shareInstance] addSelectPrintModes:0];
    
    
    
    [[EscCommand shareInstance] addSelectJustification:Left];
    
    [[EscCommand shareInstance] addText:@"Print text\nWelcome to use SMARNET printer!\n"];
    
    /* 打印繁体中文 需要打印机支持繁体字库 */
    
    [[EscCommand shareInstance] addText:@"佳博智匯票據打印機\n"];
    
    [[EscCommand shareInstance] addPrintAndLineFeed];
    
    
    [[EscCommand shareInstance] addText:@"智汇"];
    
    [[EscCommand shareInstance] addSetHorAndVerMotionUnits:7 Y:0];
    
    [[EscCommand shareInstance] addSetAbsolutePrintPosition:159];
    
    [[EscCommand shareInstance] addText:@"网络"];
    
    [[EscCommand shareInstance] addSetAbsolutePrintPosition:266];
    
    [[EscCommand shareInstance] addText:@"设备"];
    
    [[EscCommand shareInstance] addPrintAndLineFeed];
    
    
    [[EscCommand shareInstance] addText:@"Print bitmap!\n"];
    
    
    UIImage *img = [UIImage imageNamed:@"gprinter"];
    
    
    [[EscCommand shareInstance] addRastBitImage:img Alignment:Middle maxWidth:300];
    
    
    [[EscCommand shareInstance] addText:@"Print code128\n"];
    
    
    [[EscCommand shareInstance] addSelectPrintingPositionForHRICharacters:2];
    
    [[EscCommand shareInstance] addSetBarcodeHeight:60];
    
    [[EscCommand shareInstance] addSetBarcodeWidth:1];
    
    
    [[EscCommand shareInstance] addCODE128:CodeB with:@"SMARNET"];
    
    [[EscCommand shareInstance] addPrintAndLineFeed];
    
    
    [[EscCommand shareInstance] addText:@"Print QRcode\n"];
    
    
    
    
    [[EscCommand shareInstance] addSelectSizeOfModuleForQRCode:3];
    
    [[EscCommand shareInstance] addSelectErrorCorrectionLevelForQRCode:48];
    
    [[EscCommand shareInstance] addStoreQRCodeData:@"www.smarnet.cc"];
    
    [[EscCommand shareInstance] addPrintQRCode];
    
    
    
    
    [[EscCommand shareInstance] addSelectJustification:Middle];
    
    [[EscCommand shareInstance] addText:@"Completed!\r\n"];
    
    
    
    [[EscCommand shareInstance] addGeneratePlus:Pin_5];
    
    
    [[EscCommand shareInstance] addPrintAndFeedLines:8];
    
    [[EscCommand shareInstance]addCutAndFeedPaper:8];
    
    
    return [[EscCommand shareInstance]getData];
    
    
    
}


-(NSData*)TSCcommand{
    
    [[TscCommand shareInstance]addSizeWithWidth:60 withHeight:60];
    [[TscCommand shareInstance]addGap:2 with:0];
    [[TscCommand shareInstance]addDirection:BACKWARD];
    [[TscCommand shareInstance]addReference:0 with:0];
    [[TscCommand shareInstance]addTear:@"ON"];
    
    [[TscCommand shareInstance]addClS];
    
    
    [[TscCommand shareInstance] addTextWithXstart:10 withYstart:0 withFont:SIMPLIFIED_CHINESE withRotation:ROTATION_0 withMagnificationRateX:MUL_1 withMagnificationRateY:MUL_1 withContent:@"Welcome to use SMARNET printer"];
    
    //
    
    UIImage *img = [UIImage imageNamed:@"gprinter"];
    
    [[TscCommand shareInstance]addBitmapWithXstart:10 withYstart:20 withMode:0 withImage:img maxWidth:300];
    
    
    
    [[TscCommand shareInstance]addQRCodeWithXstart:10 withYstart:330 ECClevel:LEVEL_L withCellwidth:5 withMode:@"A" withRotation:ROTATION_0 withString:@"www.smarnet.cc"];
    
    
    
    [[TscCommand shareInstance]add1DBarcodeWithXstart:10 withYstart:450 withType:CODE128 withHeight:100 withREADABLE:ENABEL withROTATION:ROTATION_0 narrow:2 wide:2 withString:@"SMARNET"];
    
    
    
    
    [[TscCommand shareInstance]addPrint:1 with:1];
    
    return [[TscCommand shareInstance]getData];
    
}



#pragma mark - 测试打印
-(void)Test{
    
   
    if ([self.type isEqualToString:@"ESC"]) {
        
  
        [[EscCommand shareInstance]SendToThePrinterWithData:[self command] CallBack:^(NSData *data) {
            
        }];
        
    }else if ([self.type isEqualToString:@"TSC"]){
        
        [[TscCommand shareInstance]SendToThePrinterWithData:[self TSCcommand] CallBack:^(NSData *data) {
        }];
        
    }else{
        NSLog(@"No type to judge");
        
        [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"请先连接好打印机",nil)];
        [SVProgressHUD dismissWithDelay:1.0f];


    }
    
}


#pragma mark - 连续打印

-(void)Continuity{
    
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:nil message:NSLocalizedString(@"请输入份数",nil) preferredStyle:UIAlertControllerStyleAlert];
    //增加确定按钮；
    [alertController addAction:[UIAlertAction actionWithTitle:NSLocalizedString(@"确定",nil) style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
    
        //文字内容
        UITextField * firstTF = [[UITextField alloc]init];
        
        
        firstTF = alertController.textFields.firstObject;
        
        if (firstTF.text.length == 0) {
            
            [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"份数不能为空",nil)];
            [SVProgressHUD dismissWithDelay:0.9f];

          
            return ;
        }
        
        int i = [firstTF.text intValue];
        
     
        if (self.type.length == 0) {
            
            [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"请先连接好打印机",nil)];
            [SVProgressHUD dismissWithDelay:0.9f];

        }
        
        if ([self.type isEqualToString:@"ESC"]) {
            
            
            //
            
            NSMutableData *b =  [self command];
            
            NSMutableData *h = [NSMutableData data];

            NSData *d = [[EscCommand shareInstance]addQueryPrinterStatus];
            [h appendData:b];
            [h appendData:d];
            
            //
            while (i-- != 0) {
                
                [[EscCommand shareInstance]SendToThePrinterWithData:h CallBack:^(NSData *data) {
                    
                    NSLog(@"esc打印");
                }];
                
                //
                [[EscCommand shareInstance]PrintCompletedCallBack:^(NSData *data) {
                    NSLog(@"打印完成");
                }];
                
            }
            
        }
        else if ([self.type isEqualToString:@"TSC"]){
            
            [[TscCommand shareInstance]addSizeWithWidth:60 withHeight:60];
            [[TscCommand shareInstance]addGap:2 with:0];
            [[TscCommand shareInstance]addDirection:BACKWARD];
            [[TscCommand shareInstance]addReference:0 with:0];
            [[TscCommand shareInstance]addTear:@"ON"];
            
            [[TscCommand shareInstance]addClS];
            
            
            [[TscCommand shareInstance] addTextWithXstart:10 withYstart:0 withFont:SIMPLIFIED_CHINESE withRotation:ROTATION_0 withMagnificationRateX:MUL_1 withMagnificationRateY:MUL_1 withContent:@"Welcome to use SMARNET printer"];
            
            //
            
            UIImage *img = [UIImage imageNamed:@"gprinter"];
            
            [[TscCommand shareInstance]addBitmapWithXstart:10 withYstart:20 withMode:0 withImage:img maxWidth:300];
            
            
            
            [[TscCommand shareInstance]addQRCodeWithXstart:10 withYstart:330 ECClevel:LEVEL_L withCellwidth:5 withMode:@"A" withRotation:ROTATION_0 withString:@"www.smarnet.cc"];
            
            
            
            [[TscCommand shareInstance]add1DBarcodeWithXstart:10 withYstart:450 withType:CODE128 withHeight:100 withREADABLE:ENABEL withROTATION:ROTATION_0 narrow:2 wide:2 withString:@"SMARNET"];
            
            
            
            
            [[TscCommand shareInstance]addPrint:i with:1];
            
         
            [[TscCommand shareInstance]SendToThePrinterWithData:[TscCommand shareInstance].sendTData CallBack:^(NSData *data) {
                NSLog(@"tsc打印");
            }];
            
            
            
        }else{
           
    
            return;
            
        }
        
        
        
        
        }]];
    
    //增加取消按钮；
    [alertController addAction:[UIAlertAction actionWithTitle:NSLocalizedString(@"取消",nil) style:UIAlertActionStyleDefault handler:nil]];
    
    //定义第一个输入框;
    
    [alertController addTextFieldWithConfigurationHandler:^(UITextField * _Nonnull textField) {
        
//        textField.placeholder = @"份数" ;

    }];
    //
    
    [self presentViewController:alertController animated:true completion:nil];
    
    
    
    
}



#pragma mark - 断开
-(void)cutOffLine
{
    if (self.type.length == 0) {
        
        [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"请先连接好打印机",nil)];
        [SVProgressHUD dismissWithDelay:0.9f];
        
        [[EscCommand shareInstance]CloseHost];
        [[TscCommand shareInstance]CloseHost];

    }
   else if ([self.type isEqualToString:@"ESC"]) {
        [[EscCommand shareInstance]CloseHost];
       
        self.type = @"";
        [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"已断开",nil)];
        [SVProgressHUD dismissWithDelay:1.0f];


    }else if ([self.type isEqualToString:@"TSC"]){
        [[TscCommand shareInstance]CloseHost];
        self.type = @"";

        [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"已断开",nil)];
        [SVProgressHUD dismissWithDelay:1.0f];


    }
    
}



//收起键盘
-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event

{
    
    [_ipField resignFirstResponder];
    
    [_portField resignFirstResponder];
    
    
    
}


-(void)TextFieldDidChange:(UITextField *)textField
{
    if (self.portField.text.length>4) {
        
        [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"端口号格式错误",nil)];
        [SVProgressHUD dismissWithDelay:0.9f];


    }
    
    if (self.ipField.text.length == 0 ) {
        
        [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"ip地址不能为空",nil)];
        [SVProgressHUD dismissWithDelay:0.9f];


    }
    
    if ( self.portField.text.length == 0) {
        
        [SVProgressHUD showInfoWithStatus:NSLocalizedString(@"端口号不能为空",nil)];
        [SVProgressHUD dismissWithDelay:0.9f];

        
    }


}








- (BOOL)isIPAddressWithString:(NSString *)string
{
    if (string.length > 15) {
        
        return false;
        
    }
    NSInteger from = 0; //记录截取的初始位置
    NSInteger cutCount = 0; //记录截取次数
    NSInteger length = string.length;
    //    NSInteger to   = 0; //截取长度i-from+1
  
    for (NSInteger i = 0; i < length; i++) {
        
        unichar charactor = [string characterAtIndex:i];
        
        //判断字符规范
        if ( !((charactor>= 48 && charactor<=57) || charactor==46) )
        {
            return false;
            
        }
        //截取，判读是否在ip地址范围
        if ((charactor==46) || (i==length-1)) {
            
            NSInteger tempInt = [[string substringWithRange:NSMakeRange(from, (i-from+1))] integerValue];
            //NSLog(@"%ld", tempInt);
            
            if (!(tempInt >= 0 && tempInt <= 255)) {
                return false;
                
            }
            from = i+1;
            cutCount++;
            
        }
        
    }//判断截取次数是否满足
    if (cutCount != 4) {
        return false;
        
    }//通过所有检测
    return true;
    
}
    

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}




@end
